Archi Forum

Archi Plug-ins => Other Plug-ins => Topic started by: Manj75 on September 09, 2019, 10:25:20 AM

Title: ServiceNow plugin not working with Archi v4.5
Post by: Manj75 on September 09, 2019, 10:25:20 AM
Hi Herve,

I had recently installed Archi v4.5 with Collaboration plugin v0.5.2 and just got round to reinstalling the ServiceNow v1.5 plugin jar file and on carrying out an 'import from ServiceNow' results in an java exception as seen in the ...\AppData\Roaming\Archi4\.metadata\.log file detailing the below.  I tried it by placing the jar file in both the droping and plugin folder, and I get the same exception.

Are you able to provide a quick fix - if not I'll look at rolling back to Archi v4.4?

Hopefully you can reproduce the following - it occurs when I select the ini file to run - there is not progress bar so exception is occurring immediately.

!ENTRY org.eclipse.ui 4 0 2019-09-09 11:18:34.857
!MESSAGE Unhandled event loop exception
!STACK 0
java.lang.NoClassDefFoundError: javax/xml/bind/DatatypeConverter
   at org.archicontribs.servicenow.MyConnection.get(MyConnection.java:57)
   at org.archicontribs.servicenow.MyImporter.doImport(MyImporter.java:472)
   at com.archimatetool.editor.actions.ImportIntoModelAction.run(ImportIntoModelAction.java:37)
   at org.eclipse.jface.action.Action.runWithEvent(Action.java:474)
   at org.eclipse.jface.action.ActionContributionItem.handleWidgetSelection(ActionContributionItem.java:568)
   at org.eclipse.jface.action.ActionContributionItem.lambda$4(ActionContributionItem.java:400)
   at org.eclipse.swt.widgets.EventTable.sendEvent(EventTable.java:89)
   at org.eclipse.swt.widgets.Display.sendEvent(Display.java:4131)
   at org.eclipse.swt.widgets.Widget.sendEvent(Widget.java:1055)
   at org.eclipse.swt.widgets.Display.runDeferredEvents(Display.java:3944)
   at org.eclipse.swt.widgets.Display.readAndDispatch(Display.java:3547)
   at org.eclipse.e4.ui.internal.workbench.swt.PartRenderingEngine$5.run(PartRenderingEngine.java:1173)
   at org.eclipse.core.databinding.observable.Realm.runWithDefault(Realm.java:338)
   at org.eclipse.e4.ui.internal.workbench.swt.PartRenderingEngine.run(PartRenderingEngine.java:1062)
   at org.eclipse.e4.ui.internal.workbench.E4Workbench.createAndRunUI(E4Workbench.java:155)
   at org.eclipse.ui.internal.Workbench.lambda$3(Workbench.java:644)
   at org.eclipse.core.databinding.observable.Realm.runWithDefault(Realm.java:338)
   at org.eclipse.ui.internal.Workbench.createAndRunWorkbench(Workbench.java:566)
   at org.eclipse.ui.PlatformUI.createAndRunWorkbench(PlatformUI.java:150)
   at com.archimatetool.editor.Application.start(Application.java:84)
   at org.eclipse.equinox.internal.app.EclipseAppHandle.run(EclipseAppHandle.java:203)
   at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.runApplication(EclipseAppLauncher.java:137)
   at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.start(EclipseAppLauncher.java:107)
   at org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:400)
   at org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:255)
   at java.base/jdk.internal.reflect.NativeMethodAccessorImpl.invoke0(Native Method)
   at java.base/jdk.internal.reflect.NativeMethodAccessorImpl.invoke(Unknown Source)
   at java.base/jdk.internal.reflect.DelegatingMethodAccessorImpl.invoke(Unknown Source)
   at java.base/java.lang.reflect.Method.invoke(Unknown Source)
   at org.eclipse.equinox.launcher.Main.invokeFramework(Main.java:661)
   at org.eclipse.equinox.launcher.Main.basicRun(Main.java:597)
   at org.eclipse.equinox.launcher.Main.run(Main.java:1476)


Title: Re: ServiceNow plugin not working with Archi v4.5
Post by: Manj75 on September 09, 2019, 10:29:17 AM
I forgot to add that it would be great if you could provide a fix to the plugin jar file prior to migrating to JScript.  Primarily because we are in evaluation stage of the SN plugin and upgraded to Archi v4.5 and the JScript plugin requires payment, which I need to convince the organisation to make.

Thanks,
Manjit
Title: Re: ServiceNow plugin not working with Archi v4.5
Post by: Phil Beauvoir on September 09, 2019, 10:37:06 AM
Manjit - if by "JScript" you mean jArchi it doesn't require payment. The source code is freely available. People who have donated to Archi via PayPal or Patreon get the compiled version and jArchi examples as a thank-you for their donation. The minimum donation is $1, which I understand is not possible for some companies. ;-)
Title: Re: ServiceNow plugin not working with Archi v4.5
Post by: Manj75 on September 09, 2019, 11:08:05 AM
Hi Phil,

I'm a freelance contractor and personally will be donating from my company perspective as you've put together a fantastic tool, but it is only right for the client I work for also donate as they are using your tooling and plugins from various people as their core modeling technology - I will be persuading them to do so.

In the meantime my request is only to ensure continuity of my PoC of ServiceNow integration work with v4.5 if Herve can turnaround a quick fix.  Failing this I revert back to v4.4 until a fix is available even if that is in JArchi.

Thanks,
Manjit
Title: Re: ServiceNow plugin not working with Archi v4.5
Post by: Phil Beauvoir on September 09, 2019, 11:11:47 AM
Manjit, I was simply making it clear that there is no barrier to using jArchi as it is open source and freely available, and to make clear that the binary is given as a "thank-you" rather than a paid for plug-in.

The issue you are having is caused by Java 11 not supporting JAXB. If you delete the "jre" folder in Archi and instead use Java 8 it should work.

Phil
Title: Re: ServiceNow plugin not working with Archi v4.5
Post by: Manj75 on September 09, 2019, 12:11:18 PM
Hi Phil, your suggestion of using Java 8 worked a treat - thank you  :)

Looking into JArchi will be a subsequent step and I understand what your saying - getting the binary will be easier for my client, so will see if they are able to donate, if not I'll do down the source route.
Title: Re: ServiceNow plugin not working with Archi v4.5
Post by: Hervé on September 09, 2019, 15:49:00 PM
Hi,

I haven't tested my ServiceNow plugin with Archi 4.5 yet, so I cannot guarantee I works well with this version.

Please let me know if you experience other exceptions or misbehavior with Archi 4.5.

Thanks and regards
Hervé
Title: Re: ServiceNow plugin not working with Archi v4.5
Post by: Phil Beauvoir on September 09, 2019, 15:50:49 PM
Hi Hervé,

I think the issue is that Archi 4.5 ships with Java 11 and your plugin needs JAXB which is no longer bundled with Java 11. It was part of Java 8. You could add JAXB as a jar dependency.
Title: Re: ServiceNow plugin not working with Archi v4.5
Post by: Hervé on September 09, 2019, 20:21:14 PM
Hi Phil,

thanks for the information. I will.

Best regards
Hervé
Title: Re: ServiceNow plugin not working with Archi v4.5
Post by: Manj75 on September 10, 2019, 06:33:34 AM
Hi Herve,

No other issues the plugin works perfectly in v4.5.1 as long as it is using Java 8, but if you make JAXB as a jar dependency in a subsequent release it will work out of the box installation of the latest Archi using Java 11.

Kind Regards,
Manjit